// Fig. 9.16: Time1.cs
// Time1 class declaration in a namespace.
namespace Chapter09
{
   public class Time1
   {
      private int hour; // 0 - 23
      private int minute; // 0 - 59
      private int second; // 0 - 59

      // set a new time value using universal time; ensure that 
      // the data remains consistent by setting invalid values to zero
      public void SetTime( int h, int m, int s )
      {
         hour = ( ( h >= 0 && h < 24 ) ? h : 0 ); // validate hour
         minute = ( ( m >= 0 && m < 60 ) ? m : 0 ); // validate minute
         second = ( ( s >= 0 && s < 60 ) ? s : 0 ); // validate second
      } // end method SetTime

      // convert to string in universal-time format (HH:MM:SS)
      public string ToUniversalString()
      {
         return string.Format( "{0:D2}:{1:D2}:{2:D2}",
            hour, minute, second );
      } // end method ToUniversalString

      // convert to string in standard-time format (H:MM:SS AM or PM)
      public override string ToString()
      {
         return string.Format( "{0}:{1:D2}:{2:D2} {3}",
            ( ( hour == 0 || hour == 12 ) ? 12 : hour % 12 ),
            minute, second, ( hour < 12 ? "AM" : "PM" ) );
      } // end method ToString
   } // end class Time1
} // end namespace Chapter09

/**************************************************************************
 * (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
 * Pearson Education, Inc. All Rights Reserved.                           *
 *                                                                        *
 * DISCLAIMER: The authors and publisher of this book have used their     *
 * best efforts in preparing the book. These efforts include the          *
 * development, research, and testing of the theories and programs        *
 * to determine their effectiveness. The authors and publisher make       *
 * no warranty of any kind, expressed or implied, with regard to these    *
 * programs or to the documentation contained in these books. The authors *
 * and publisher shall not be liable in any event for incidental or       *
 * consequential damages in connection with, or arising out of, the       *
 * furnishing, performance, or use of these programs.                     *
 *************************************************************************/
